#ifndef MPLS_PARSER
#define MPLS_PARSER

#include <libxml++/libxml++.h>
#include <vector>
#include <string>

using namespace std;

class SplitRatiosParser : public xmlpp::SaxParser
{
public:
  SplitRatiosParser ();
  virtual ~SplitRatiosParser();

  // parameters
  bool rdas;
  float alpha;
  string topofile;

  vector<pair<string,double> > numericValues;
  vector<pair<string,int> > integerValues;
  vector<pair<string,string> > stringValues;


protected:
  
  //overrides:
  virtual void on_start_document();
  virtual void on_end_document();
  virtual void on_start_element(const Glib::ustring& name,
                                const AttributeList& properties);
  virtual void on_end_element(const Glib::ustring& name);
  virtual void on_characters(const Glib::ustring& characters);
  virtual void on_comment(const Glib::ustring& text);
  virtual void on_warning(const Glib::ustring& text);
  virtual void on_error(const Glib::ustring& text);
  virtual void on_fatal_error(const Glib::ustring& text);
};


#endif //MPLS_PARSER
