#ifndef TOP_H
#define TOP_H

#include "ns3/core-module.h"
#include "ns3/mobility-module.h"
#include "ns3/wifi-module.h"
#include "ns3/olsr-helper.h"
#include "ns3/ipv4-static-routing-helper.h"
#include "ns3/ipv4-list-routing-helper.h"
#include "ns3/olsr-routing-protocol.h"

#include "ns3/layer-protocol.h"
#include "ns3/layer-rtable.h"

#include <iostream>
#include <fstream>
#include <vector>
#include <limits>
#include <set>

//#include "ns3/global-route-module.h"
#include "ns3/mesh-module.h"
#include "ns3/mobility-module.h"
#include "ns3/mesh-helper.h"

#include <sstream>

using namespace std;
using namespace ns3;

void QueryOlsrd(NodeContainer);
//Mac48Address getMac(const Ipv4Address, const NodeContainer);


class Nodo{
	private:
		Ipv4Address ip;
		uint16_t id;
	public:
		Nodo(){};
		Nodo(const Nodo &n) { id=n.getId(); ip=n.getIp(); }
		Nodo(const Ipv4Address a) : ip(a) {}
		~Nodo(){};
		void setIp(const Ipv4Address a) { ip=a; }
		void setId(const uint16_t i) { id=i; }
		Ipv4Address getIp()const { return ip; }
		uint16_t getId()const { return id; }	
};


// rappresenta un nodo e l'insieme dei suoi vicini visti come un set di interi
//che rappresentano gli indici dei rispettivi nodi nella topologia
struct N{
	Nodo n;
	set<uint16_t> v;
};

//classe utilizzata per dijkstra
class TNodePro{
	public:
		float distance;
		uint16_t prev_link;
		/* constructor */
		TNodePro() : distance(INFINITY) {}
};

//classe utilizzata per dijkstra
class lessDistant {
	vector<TNodePro>* v;
	public:
		lessDistant(vector<TNodePro>* _v) : v(_v) {}
		bool operator()(const uint16_t x, const uint16_t y) { return (v->at(x)).distance < (v->at(y)).distance; }
};

//la topologia è un vettore di struct
class top {
	private:
		
	public:
	
	vector <N> t;
		top(){};
		~top(){};
		void popola(const olsr::OlsrState *);
		void inserisci(const Ipv4Address,const Ipv4Address);
		uint16_t trova(const Ipv4Address);
		void crea(const Ipv4Address);
		void stampa()const;
		
		vector<TNodePro> Dijkstra(const uint16_t);
		void stampaDistanze(int id);
};
#endif
